========================================
Change log for mod_hotpot
========================================

2022-09-15 (48)
 - fix error caused by NULL intro field

2022-09-06 (47)
 - fix compatibility with PHP 8.x and Moodle 4.x (1) remove use of curly braces on strings; (2) add 'intro' and 'introformat' fields; (3) use custom version of utf8_to_entities() that does not convert strings to lowercase;

2021-09-14 (46)
 - modify markdown syntax for long help messages (for compatability with Moodle 3.11)

2020-06-05 (44)
 - mod/hotpot convert URLs in 'src' attribute of <audio> and <video> tags

2020-03-01 (43)
 - include current version in tool to redo upgrade

2019-10-12 (41)
 - msd_hotpot standardize layout and spelling in CHANGES.txt

2019-07-28 (40)
 - add db/subplugins.json for compatability with Moodle >= 3.8

2019-07-17 (39)
 - separate '<?' to '< ?' so that it is not mistaken for a PHP short tag

2019-05-30 (38)
 - remove 'continue' statement inside SWITCH block

2019-04-05 (37)
 - add comments about events_trigger availability

2019-03-30 (36)
 - ensure 'modname' is defined when creating new activities in Moodle >= 3.5

2019-02-13 (35)
 - fix URL of secondary zip download site

2019-02-13 (35)
 - fix force_update tool for compatability with Moodle >= 2.7

2019-01-21 (34)
 - remove use of 'events_trigger' for compatability with Moodle 3.6

2019-01-21 (33)
 - (1) CONTRIB-7098 fix 'non-numeric value' warning in PHP 7.1; (2) fix 'cannotexecduringupgrade' error when modifying HotPot grades during Moodle upgrade

2018-12-08 (32)
 - remove misplaced 'use' line in main privacy file for HotPot module

2018-12-07 (31)
 - add polyfill to privacy providers to prevent errors in PHP 5.x

2018-12-07 (30)
 - Merge pull request #17 from Anupamatd/hotpot_privacy_api

2018-09-10 (29)
 - Merge pull request #17 from Anupamatd/hotpot_privacy_api Incorporated Privacy API. Many thanks to Anupamatd for all your work on this improvement.

2018-09-10 (29)
 - fix URL for Moodle message feedback in Moodle >= 3.2

2018-06-30 (27)
 - fix location of parentNode in JMix under Boost theme

2018-06-29 (25)
 - fix addition of navigation nodes in Moodle 2.0

2018-06-29 (24)
 - display reports in Admin menu in Moodle >= 2.5 to ensure that they remain accessible in Boost theme

2018-06-29 (23)
 - investigate fix retrieval of HotPot release in Moodle >= 2.7

2018-06-26 (22)
 - replace shorthand declaration of array, [...], with standard array(...) for compatability with PHP 5.3

2018-06-02 (21)
 - remove superfluous openpopup function from hp/6/renderer.php

2018-06-02 (20)
 - add missing global $CFG in hp/6/renderer.php

2018-05-30 (19)
 - add output format descriptor strings for Rottmeier DropDown and JGloss

2018-05-30 (18)
 - replace each() with key(), continue() and next() for compatability with PHP 7.2

2018-05-29 (17)
 - replace 'each()' with 'foreach()' for compatability with PHP 7.2

2018-05-25 (16)
 - add to <open-text> tags to JCloze XML to account for new behavior of XML parser in Moodle >= 3.5

2018-04-21 (15)
 - fix activity-navigation bar (Moodle >= 3.4) being covered by position:absolute and floating elements

2018-04-20 (14)
 - in responses report, replace deprecated tick/cross icons in Moodle >= 2.5

2017-12-28 (13)
 - add composer.json

2017-10-26 (12)
 - CONTRIB-7098 fix warning on PHP 7.1: A non-numeric value encountered in "mod_form.php" on line 789

2017-10-04 (11)
 - Added support for block_myoverview in Moodle 3.3+

2017-10-03 (10)
 - replace use of deprecated JS functions in Moodle 3.3: select_all_in, deselect_all_in

2017-09-14 (08)
 - fix positioning of JMatch items and box sizing on templatable themes in Moodle >= 3.3

2017-04-27 (07)
 - replace use of pix_url for compatability with Moodle >= 3.3

2017-04-27 (07)
 - use 'image_url' instead of 'pix_url' for compatabaility with Moodle >= 3.3

2017-04-17 (06)
 - fix undefined property 'TC' introduced after recent change to the way edit icons are generated

2017-04-14 (05)
 - use pix_icon instead of pix_url for compatability with Moodle 3.3

2017-04-01 (04)
 - remove unused file: attempt/hp/6/jmix/xml/v6/plus/deluxe/class.php

2017-04-01 (03)
 - Fix 'Unexpected character in input' warning in PHP 7.1

2017-03-22 (02)
 - fix 'Unsupported $module syntax' warning during installation via CLI

2017-02-15 (01)
 - convert relative URLs in add HTML5 <track> tags

2016-10-06 (00)
 - fix enabling and disabling of filter on Moodle 3.x

2016-09-15 (99)
 - handle self-modified HP html files that have no Begin|EndSubmissionsForm markers

2016-07-24 (98)
 - fix JCross and JMemori (JMatch) button captions with apostrophe

2016-07-16 (97)
 - Moodle coding standards compatability: remove all usage of 'print' and 'create_function' in PHP code

2016-06-14 (96)
 - small improvements to coding style in mod_form.php

2016-06-13 (95)
 - add grade settings to the mod_form.php page

2016-06-13 (94)
 - add grade category setting to mod_form.php

2016-06-09 (93)
 - use $CFG->branch to detect Moodle's major version in version.php

2016-06-01 (92)
 - fix display of recent Xerte (SWF) quizzes

2016-05-11 (91)
 - fix detection of completion conditions for 'Student must receive grade'

2016-04-25 (90)
 - fix access to folders in 'filesystem' repository in Moodle >= 3.1

2016-04-21 (89)
 - remove unwanted reportclicktrail folder from github repository

2016-04-20 (88)
 - fix updaing of completion status when using COMPLETION_TRACKING_MANUAL

2016-04-20 (88)
 - fix updaing of completion status when using COMPLETION_TRACKING_AUTOMATIC

2016-01-12 (87)
 - CONTRIB-6084 fix display of HTML entities in JCross hints

2016-01-05 (86)
 - remove incorrectly named report folders

2015-12-30 (85)
 - fix small incompatabilities with Moodle 3.0

2015-11-06 (84)
 - fix SQL syntax error in upgrade script

2015-11-05 (83)
 - fix bug that prevented JMatch FlashCard from finishing

2015-11-03 (82)
 - remove obsolete hotpot_get_completion_state_old() function from lib.php

2015-11-03 (82)
 - fix activity completion when status becomes completed

2015-11-01 (81)
 - improve detection and reporting of faulty HTML tags in JQuiz questions

2015-10-29 (80)
 - standardize white spce in JS template files for JCloze and JQuiz

2015-10-28 (79)
 - remove troublesome ascii control chars from HP XML files, and handle floating elements when setting canvas height in browser

2015-10-26 (78)
 - add completion critera: (1) require minimum grade, (2) require passing grade, (3) require completed status

2015-10-07 (77)
 - standardize format of release string in version.php

2015.10.01 (76)
 - disable FEATURE_CONTROLS_GRADE_VISIBILITY as it was not being used

2015.10.01 (75)
 - disable advanced grading as it was not being used

2015.09.27 (74)
 - added missing strings for JCloze Find-It (a)

2015.09.03 (73)
 - fix syntax error in file/hp/class.php

2015.09.03 (72)
 - fix URLs in JCloze clues

2015.07.09 (70)
 - CONTRIB-5819 improve wording of delay3: Use specific delay

2015.06.02 (69)
 - fix value f return status in continue buttons for html files

2015.05.14 (68)
 - improve Moodle version detection using compare_version

2015.05.13 (67)
 - allow detection of Moodle version from $CFG->yui3version, if $CFG->release is not available, for example when installing from the CLI using PHPunit

2015.04.12 (66)
 - improve comments in settings.php

2015.04.12 (66)
 - compatability with Moodle 2.9: use core_date::get_user_timezone() instead of get_user_timezone_offset()

2015.04.05 (65)
 - fix checking of activity visibility on Moodle >= 2.7; fix detection of legacy course files

2015.03.03 (64)
 - when updating files to Moodle 2.x, use aliasses to files repositories, when possible

2015.02.18 (63)
 - small code optimizationwhen converting tap/click events

2015.02.11 (62)
 - standardize white space (tab -> 4 spaces) in *.js file

2015.02.11 (62)
 - handle devices that detect both mouse events and tap events

2015.01.26 (59)
 - simplify version.php files HotPot subplugins

2015.01.26 (58)
 - add version.php files for all subplugins

2015.01.20 (57)
 - fix faulty conversation of decimal HTML entities with leading zero in Moodle <= 2.5

2015.01.16 (56)
 - fix sql to select userfields in get_recent_mod_activity for Moodle >= 2.5

2015.01.06 (55)
 - limit display of HotPots on MyMoodle page to activities that are open and are not closed, i.e. the open date is in the past and the closing deadline has not yet passed

2015.01.03 (54)
 - add source and output class for hp_6_jmatch_html_sort

2014.12.28 (53)
 - rename variable to standard name in locallib.php

2014.12.28 (53)
 - hide progress bar when updating via command line

2014.12.22 (52)
 - add HotPot activities to MyMoodle page

2014.12.19 (51)
 - fix display of event description and explanation in Site admin -> Reports -> Logs and Events list

2014.12.17 (50)
 - fix error adding and updating logs for HotPot 'view all' event

2014.12.16 (48)
 - add missing base event class

2014.12.13 (47)
 - add missing 'base' event class

2014.12.12 (46)
 - always report view event in log, even when there is no entry page

2014.12.11 (45)
 - use a base class to optimize classes/event

2014.12.11 (45)
 - small fix in hotpot_get_view_actions: rename 'viewindex' to 'index'

2014.12.10 (44)
 - fix setting of action in legacy log table

2014.12.09 (43)
 - fix double logging of events in legacy log table

2014.12.05 (42)
 - fix 'crud' settings in event classes

2014.12.04 (41)
 - fix update error: Undefined variable DB

2014.12.04 (40)
 - fix upgrading error: The course_module_viewed event must define objectid and object table

2014.12.01 (39)
 - remove calls to init() in classes/event/*.php files

2014.11.28 (38)
 - hide update progress bar when updating via CLI

2014.11.28 (37)
 - enable new 'standard' logging on HotPot module

2014.11.27 (35)
 - allow 'lazy' detection and transfer of files from Private Files to sourcefile file-area

2014.11.24 (34)
 - fix position of feedback in JGloss

2014.11.21 (34)
 - fix error undefined static property this on JMix (keypress) and Rhubarb

2014.11.11 (33)
 - fix VIEW completion on HotPot module

2014.11.11 (33)
 - fix VIEW completion on HotPot module

2014.10.04 (32)
 - fix static call to non-static function format_score

2014.09.19 (31)
 - fix 'version value is missing from version.php'

2014.09.19 (30)
 - fix 'Undefined variable  version.php'

2014.09.19 (29)
 - fix 'Missing version value in version.php' in Moodle 2.4 - 2.5

2014.09.19 (28)
 - fix 'Missing version value in version.php' in Moodle 2.4 and 2.5

2014.09.14 (27)
 - fix handling of unicode characters in main text of Rhubarb exercises

2014.07.04 (26)
 - reword 'Source file name' to 'Source file'

2014.07.04 (26)
 - fix all calls to get_string() to use 'mod_hotpot'

2014.07.02 (25)
 - fix urls for Windows Media Player using 'url' in PARAM tag

2014.06.26 (24)
 - fix sorting of sub/superscript chars in keypad

2014.06.18 (23)
 - fix JMatch/JMix drag and drop in Firefox

2014.06.16 (22)
 - fix JMix v6+ with audio player

2014.06.16 (21)
 - fix audio players on JMatch drag-and-drop

2014.06.13 (20)
 - fix JMatch and JMix drag-and-drop on touch screens

2014.06.06 (19)
 - CONTRIB-5100 fix JMix restart button to move all tiles/segment back to their original positions

2014.06.04 (18)
 - fix warning about events API in Moodle 2.8

2014.05.30 (17)
 - fix use of undefined FEATURE_xxx constants in Moodle 2.0

2014.05.28 (16)
 - fix undefined $DB hen restoring HotPot in Moodle 2.x

2014.05.24 (15)
 - add _get_completion_state function required for course/activity completion

2014.05.04 (14)
 - fix migration of HotPot source files in site files folder when upgrading from Moodle1 to Moodle2

2014.04.27 (13)
 - reword version.php to pass moodle.org repository validation checks

99.99.99
2014.04.27 (13)
 - reword version.php to pass moodle.org repository validation checks

99.99.99
2014.04.27 (13)
 - reword version.php to pass moodle.org repository validation checks

99.99.99
2014.04.27 (13)
 - reword version.php to pass moodle.org repository validation checks

2014.04.21 (11)
 - fix glossary filter of HotPot exercises in Moodle >= 2.3

2014.03.22 (10)
 - exclude hotpot missing course id from grade update

2014.03.18 (09)
 - fix detection of strings to be filtered, and a typo in the restore script

2014.03.18 (08)
 - fix incorrect table name when restoring entrycm and exitcm

2014.03.16 (07)
 - backup and restore entrycm and exitcm

2014.03.16 (06)
 - fix restore of hotpot responses and strings

2014.03.14 (05)
 - use new core_text class instead of textlib in Moodle >= 2.6

2014.03.03 (04)
 - CONTRIB-4910 mod/hotpot fix Oracle error: 'duplicate column names userid' on HotPot report pages

2014.03.02 (03)
 - further improve positioning of elements in JMatch intro output format

2014.02.28 (02)
 - only apply filters to text outside of html tags

2014.02.27 (01)
 - fix use of deprecated filter_text

2014.02.27 (01)
 - fix display on JMatch intro

2014.02.10 (00)
 - remove style and script tags from quiz name in HTML files

2014.01.26 (99)
 - fix continue button on tasks using HTML files

2014.01.24 (98)
 - pass browser content through filters

2014.01.22 (97)
 - make recent_activity function compatible with Moodle <= 2.3

2014.01.22 (96)
 - fix small typo causing error in recent_activity report

2014.01.17 (95)
 - use modinfo methods instead of direct access to properties

2014.01.16 (94)
 - fix hotpot_update_grades() is not defined message from hotpot upgrade script

2014.01.16 (93)
 - small optimaization to code that calculates grades for all hotpots

2014.01.16 (93)
 - make import_hotpot_tables compatible with Moodle >= 2.6

2014.01.16 (93)
 - remove unecessary HotPot grade items

2014.01.15 (92)
 - fix small typo in hp.js in end_of_quiz() function

2014.01.15 (92)
 - remove hotpot grade from gradebook if not required; remove grade filter and column from hotpot reports if not required

2014.01.15 (91)
 - do not require grade record for HotPot reports

2013.12.17 (90)
 - add new utility import_hotpot_tables

2013.12.17 (90)
 - fix Call-time pass-by-reference has been removed errors in hotpot/attempt/review.php

2013.12.17 (89)
 - fix Undefined property: duration in storage.php

2013.11.16 (88)
 - ensure StartUp is not run more than once

2013.11.16 (87)
 - improve format of date format in force_autoupdate utility

2013.11.16 (86)
 - rename templatefolders to templatesfolders

2013.11.16 (86)
 - rename templatesfolders to templatefolders

2013.11.16 (86)
 - override Moodle theme button background image (if any)

2013.11.16 (86)
 - fix order of static public function keyswords

2013.11.16 (86)
 - add new JMatch Sort output format

2013.11.16 (85)
 - add allowpaste field to hotpot_cache table

2013.11.16 (85)
 - optimize recent updates to add fields to tables in database

2013.11.16 (85)
 - add new setting to allow/disallow paste

2013.11.15 (84)
 - fix paths to autoadvance images

2013.10.21 (83)
 - Moodle mod/hotpot include date in module release

v3.0.82
 - add force_update utility
 - add new additiaional names fields on HotPot reports and 'classes' folder for compatibility with Moodle 2.6

v3.0.81
 - fix error: Argument 4 passed to hotpot_extend_navigation() must be an instance of stdClass
 - CONTRIB-4698 fix invalid CSS color: auto

v3.0.80
 - small change to comment in hp.js
 - fix error when source/config repositoryids are not set in hotpot_cache

v3.0.79
 - improve detection of changed source files in private files area

v3.0.78
 - slight alteration to logic in locate_js_block(), and new js function HP_remove_listener to remove js event handlers
 - standardize HP function names to use prefix 'HP_'
 - make SuppressBackspace function use modern browser standards of preventDefault() and event.returnValue and replace onkeypress with onkeydown

v3.0.76
 - use textlib to convert input file content to utf-8, instead of explicitly called iconv or mb_convert_encoding
 - improve performance of Rhubarb STOP button
 - improve performance of Sequitur STOP button
 - verify new STOP and abort functionality in Seuitur nad Rhubarb quizzes
 - fix 'Unable to insert submission form' error which sometimes occurs when the contents of newly added HotPot files are not immediately available via the standard Moodle file API
 - remove select effect when dragging in JMatch and JMix

v3.0.72
 - optimize sending of results when HotPot activity finishes unexpectedly (STOP button, navigate away, time out etc)
 - allow pasting of answers if window.allow_paste_input = true

v3.0.71
 - tidy up version.php (no change to version number)
 - refine review and index pages to only show data allowed by reviewoptions

v3.0.70
 - preliminary implementation of reviewoptions functionality

v3.0.69
 - reset minimum required Moodle version in version.php
 - use explicit INNER JOIN in reports instead of implicit JOIN

v3.0.68
 - (1) include ALL attempts in reports - even those which have no grade item yet; (2) force results to be saved in Chrome and other browsers which have no onunload event

v3.0.66
 - fix 'sourcefile' field in HotPots that were previously restored from Moodle 1.9 to 2.x

v3.0.65
 - remove debug line which caused 'http' prefix to be added to all HotPot source file paths when restoring from Moodle 1.9 to 2.x
 - fix Hint/ShowAnswer button in FindIt
 - microincrement version number to force clearing of cache

v3.0.63
 - fix JQuiz score when STOP button is pressed after only a few questions have been attempted
 - fix error 'objtec could not be converted to int' when STOP button is enabled
 - don't use deprecated get_all_sections in Moodle >= 2.3
 - remove unecessary u.id AS userid from report extraction sql, as it causes as error on Oracle DBs
 - for fix warnings on forms
 - microincrement version number for nw release for fix warnings on forms

v3.0.60
 - allow teachers to start sidestep limit on number of attempts

v3.0.59
 - fix feedback messaging and webpages and microincrement version number

v3.0.58
 - remove call by reference in mod/hotpot/report/analysis/renderer.php

v3.0.57
 - allow for song_url as a parameter name to hold a relative URL

v3.0.56
 - use 0/1 instead of false/true for HTTP_NO/204_RESPONSE constants, and small improvement to readability of send_response method
 - fix error storing results after clicking STOP button

v3.0.55
 - implement delay3 setting functionality so that quiz does not continue automatically after it is completed

v3.0.54
 - Moodle2.x mod/hotpot add pix/icon.svg

v3.0.53
 - moodle.2x mod/hotpot allow for url in sourcefile field when importing Moodle 1.x backup into a Moodle 2.x site
 - remove any unwanted 'course_files' folders that may have been created when restoring Moodle 1.9 HotPot activities to a Moodle 2.x site

v3.0.52
 - fix filepath of file restored from Moodle 1.x
 - fix Moodle 2.x upgrade of HotPot activities whose reference is a URL
 - fix cvs/git/svn ignore files
 - add missing get_view/post_actions
 - fix cvs/git/svn ignore files
 - Moodle.2x add mod/hotpot and question/format/hotpot
